// Generated by CoffeeScript 1.3.3
(function() {
  var ConsoleReporter, cliColor;

  cliColor = typeof require === "function" ? require('cli-color') : void 0;

  ConsoleReporter = (function() {

    ConsoleReporter.prototype.errors = null;

    ConsoleReporter.prototype.config = null;

    ConsoleReporter.prototype.passed = 0;

    ConsoleReporter.prototype.failed = 0;

    ConsoleReporter.prototype.total = 0;

    function ConsoleReporter(config) {
      var _base, _base1, _base2, _base3, _base4, _base5, _base6, _ref, _ref1, _ref2, _ref3, _ref4, _ref5, _ref6;
      this.errors || (this.errors = []);
      this.config || (this.config = config || {});
      if ((_ref = (_base = this.config).start) == null) {
        _base.start = '';
      }
      if ((_ref1 = (_base1 = this.config).fail) == null) {
        _base1.fail = ' ✘  ';
      }
      if ((_ref2 = (_base2 = this.config).pass) == null) {
        _base2.pass = ' ✔  ';
      }
      if ((_ref3 = (_base3 = this.config).sub) == null) {
        _base3.sub = ' ➞  ';
      }
      if ((_ref4 = (_base4 = this.config).failHeading) == null) {
        _base4.failHeading = 'Failure #%s:';
      }
      if ((_ref5 = (_base5 = this.config).summaryPass) == null) {
        _base5.summaryPass = "%s/%s tests ran successfully, everything passed";
      }
      if ((_ref6 = (_base6 = this.config).summaryFail) == null) {
        _base6.summaryFail = "%s/%s tests ran successfully, %s failed";
      }
      if (cliColor != null) {
        this.config.fail = cliColor.red(this.config.fail);
        this.config.pass = cliColor.green(this.config.pass);
        this.config.sub = cliColor.gray(this.config.sub);
        this.config.failHeading = cliColor.red.underline(this.config.failHeading);
        this.config.summaryPass = cliColor.green.underline(this.config.summaryPass);
        this.config.summaryFail = cliColor.red.bold.underline(this.config.summaryFail);
      }
    }

    ConsoleReporter.prototype.getSuiteName = function(suite) {
      var parentSuiteName, suiteName;
      suiteName = suite.name;
      if (suite.parentSuite) {
        parentSuiteName = this.getSuiteName(suite.parentSuite);
        suiteName = "" + parentSuiteName + this.config.sub + suiteName;
      }
      return suiteName;
    };

    ConsoleReporter.prototype.getTestName = function(suite, testName) {
      var suiteName;
      suiteName = this.getSuiteName(suite);
      testName = "" + suiteName + this.config.sub + testName;
      return testName;
    };

    ConsoleReporter.prototype.startSuite = function(suite) {
      var message, suiteName;
      suiteName = this.getSuiteName(suite);
      message = "" + suiteName + this.config.start;
      return console.log(message);
    };

    ConsoleReporter.prototype.finishSuite = function(suite, err) {
      var check, message, suiteName;
      suiteName = this.getSuiteName(suite);
      check = (err ? this.config.fail : this.config.pass);
      message = "" + suiteName + check;
      return console.log(message);
    };

    ConsoleReporter.prototype.startTest = function(suite, testName) {
      var message;
      ++this.total;
      testName = this.getTestName(suite, testName);
      message = "" + testName + this.config.start;
      return console.log(message);
    };

    ConsoleReporter.prototype.finishTest = function(suite, testName, err) {
      var check, message;
      if (err) {
        this.errors.push({
          suite: suite,
          testName: testName,
          err: err
        });
        ++this.failed;
      } else {
        ++this.passed;
      }
      testName = this.getTestName(suite, testName);
      check = (err ? this.config.fail : this.config.pass);
      message = "" + testName + check;
      return console.log(message, (typeof process !== "undefined" && process !== null) === false && err ? [err, err.stack] : '');
    };

    ConsoleReporter.prototype.exit = function() {
      var err, error, index, suite, testName, _i, _len, _ref;
      if (this.errors.length === 0) {
        console.log("\n" + this.config.summaryPass, this.passed, this.total);
      } else {
        console.log("\n" + this.config.summaryFail, this.passed, this.total, this.errors.length);
        _ref = this.errors;
        for (index = _i = 0, _len = _ref.length; _i < _len; index = ++_i) {
          error = _ref[index];
          suite = error.suite, testName = error.testName, err = error.err;
          testName = this.getTestName(suite, testName);
          console.log("\n" + this.config.failHeading, index + 1);
          console.log("" + testName + "\n" + (err.stack.toString()));
        }
      }
      return console.log('');
    };

    return ConsoleReporter;

  })();

  if (typeof module !== "undefined" && module !== null) {
    module.exports = ConsoleReporter;
  } else {
    this.joe.ConsoleReporter = ConsoleReporter;
  }

}).call(this);
